VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CRndAccu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'****************************************************
'* CRndAccu.cls                                     *
'* Random accumulator class                         *
'* this class accumulates an array of random        *
'* classes for simultaneous use                     *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 23.04.2003 18:10                    *
'* Version: 1.0.0                                   *
'****************************************************
Option Explicit

Private Const MAX   As Long = 2147483645

Private m_Rnd()     As CRandom
Private m_lRndCnt   As Long
'----------------------------------------------------

Private Sub Class_Terminate()
    Dim I   As Long
    
    For I = 0 To m_lRndCnt
        Set m_Rnd(I) = Nothing
    Next I
End Sub
'----------------------------------------------------

'----------------------------------------------------
' Property Get/Let Count As Long
' returns or sets the number of random generators to use
'----------------------------------------------------
Public Property Get Count() As Long
    Count = m_lRndCnt + 1
End Property
Public Property Let Count(Value As Long)
    Dim I   As Long
    
    m_lRndCnt = Value - 1
    
    ReDim m_Rnd(m_lRndCnt) As CRandom
    
    For I = 0 To m_lRndCnt
        Set m_Rnd(I) = New CRandom
    Next I
End Property
'----------------------------------------------------

'----------------------------------------------------
' Property Let Seed As Long
' assigns a seed value to the next random generator
'----------------------------------------------------
Public Property Let Seed(Value As Long)
    Static CurrentRnd   As Long
    
    m_Rnd(CurrentRnd).Seed Value
    
    CurrentRnd = CurrentRnd + 1
    If CurrentRnd > m_lRndCnt Then _
        CurrentRnd = 0
End Property

'----------------------------------------------------
' Random As Long
' retrieves the random value of the next random
' generator
'----------------------------------------------------
Public Function Random( _
  Optional ByVal iMin As Long = 0, _
  Optional ByVal iMax As Long = MAX _
) As Long
    Static CurrentRnd   As Long
    
    Random = m_Rnd(CurrentRnd).Random(iMin, iMax)
    
    CurrentRnd = CurrentRnd + 1
    If CurrentRnd > m_lRndCnt Then _
        CurrentRnd = 0
End Function
