VERSION 5.00
Begin VB.Form dlgMain 
   BorderStyle     =   5  'nderbares Werkzeugfenster
   Caption         =   "Advanced Vigenre Sample"
   ClientHeight    =   3780
   ClientLeft      =   60
   ClientTop       =   330
   ClientWidth     =   6105
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3780
   ScaleWidth      =   6105
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   60
      TabIndex        =   4
      Top             =   3240
      Width           =   1455
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "&Action"
      Height          =   375
      Left            =   60
      TabIndex        =   3
      Top             =   2820
      Width           =   1455
   End
   Begin VB.TextBox txtPassword 
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   8.25
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      IMEMode         =   3  'DISABLE
      Left            =   1080
      PasswordChar    =   "h"
      TabIndex        =   2
      Top             =   1920
      Width           =   4575
   End
   Begin VB.ListBox lstFiles 
      Height          =   1815
      Left            =   60
      MultiSelect     =   2  'Erweitert
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   60
      Width           =   5595
   End
   Begin VB.Label Label1 
      BackColor       =   &H00FF0000&
      BackStyle       =   0  'Transparent
      Caption         =   "&Passphrase:"
      ForeColor       =   &H00FF0000&
      Height          =   255
      Left            =   60
      TabIndex        =   1
      Top             =   2400
      Width           =   975
   End
End
Attribute VB_Name = "dlgMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

Private CryptoInstance  As CCrypto
'----------------------------------------------------

Private Sub cmdAction_Click()
    Dim Files() As String
    Dim I       As Long
    
    If Not CBool(Len(txtPassword.Text)) Then _
        Exit Sub
    
    If lstFiles.ListCount = 0 Then _
        Exit Sub
    
    ReDim Files(lstFiles.ListCount - 1) As String
    
    For I = 0 To lstFiles.ListCount - 1
        If FileExists(lstFiles.List(I)) Then _
            Files(I) = lstFiles.List(I)
    Next I
    
    Call EncodeFiles(Files)
End Sub

Private Sub cmdExit_Click()
    Call Unload(Me)
End Sub

Private Sub Form_Activate()
    Call InitCommonControls
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    Select Case LCase$(Chr$(KeyAscii))
        Case "p"
            txtPassword.SetFocus
        Case "a"
            cmdAction.SetFocus
        Case "x"
            cmdExit.SetFocus
    End Select
End Sub

Private Sub Form_Load()
    Call TreatArgs
    
    If lstFiles.ListCount = 0 Then
        Dim Message As String
        
        Message = "Keine Dateien bergeben." & vbCrLf & _
          "Zur Benutzung bitte die zu verschlsselnden Dateien auf die Anwendung " _
          & "ziehen oder die Dateien als Befehlszeilenparameter bergeben!"
        Call MsgBox(Message, vbInformation, "Sorry...")
        Call Unload(Me)
        Exit Sub
    End If
    
    Set CryptoInstance = New CCrypto
End Sub

Public Function SplitCommandLine( _
  Optional Value As String _
) As String()
    Dim I           As Long
    Dim Char        As String * 1
    Dim bQuote      As Boolean
    Dim Result()    As String
    Dim CurrVal     As Long
    
    CurrVal = -1
    
    If LenB(Value) = 0 Then _
        Value = Command$
    
    For I = 1 To LenB(Value) Step 2
        Char = MidB$(Value, I, 2)
        
        Select Case Char
        Case " ", vbTab
            If bQuote Then
                GoSub AddVal
            Else
                If CurrVal + 1 Then
                    If LenB(Result(CurrVal)) Then
                        CurrVal = CurrVal + 1
                        ReDim Preserve Result(CurrVal) As String
                    End If ' LenB()
                End If ' CurrVal + 1
            End If ' bQuot
        Case """"
            bQuote = Not bQuote
        Case Else
            GoSub AddVal
        End Select ' Char
    Next I
    
    SplitCommandLine = Result
    
    Exit Function
    '----------------------------------------------------
AddVal:
    If CurrVal = -1 Then
        CurrVal = 0
        ReDim Result(0) As String
    End If
    
    Result(CurrVal) = Result(CurrVal) & Char
Return ' AddVal
End Function

Private Sub Form_Resize()
    Dim MinHi   As Long, _
        MinWi   As Long
    On Error Resume Next
    
    MinHi = 240 * Screen.TwipsPerPixelY
    MinWi = 200 * Screen.TwipsPerPixelX
    
    If Width < MinWi Then
        Width = MinWi
        Exit Sub
    End If
    If Height < MinHi Then
        Height = MinHi
        Exit Sub
    End If
    
    With cmdExit
        .Move .Left, ScaleHeight - .Height - .Left
        cmdAction.Move .Left, .Top - .Height - .Left
    End With
    
    With txtPassword
        .Move .Left, cmdAction.Top - .Height - 2 * lstFiles.Top, _
          ScaleWidth - lstFiles.Left - .Left
        lstFiles.Move lstFiles.Left, lstFiles.Top, .Width + .Left - lstFiles.Left, _
          .Top - lstFiles.Top
        
        Label1.Move lstFiles.Left, .Top
    End With
    
    On Error GoTo 0
End Sub

Private Sub txtPassword_GotFocus()
    cmdAction.Default = True
    KeyPreview = False
End Sub

Private Sub txtPassword_LostFocus()
    KeyPreview = True
End Sub
'----------------------------------------------------

Public Sub TreatArgs()
    Dim argv()  As String
    Dim I       As Long
    
    argv = SplitCommandLine
    
    On Error Resume Next
    If UBound(argv) < 0 Then _
        Exit Sub
    On Error GoTo 0
    
    For I = 0 To UBound(argv)
        lstFiles.AddItem argv(I)
    Next I
End Sub

Public Function FileExists(Path As String) As Boolean
    Const NotFile = vbDirectory Or vbVolume
    
    On Error Resume Next
    FileExists = (GetAttr(Path) And NotFile) = 0
    On Error GoTo 0
End Function

Public Sub EncodeFiles(Files() As String)
    Dim I       As Long
    Dim ff      As Long
    Dim Buff()  As Byte
    Dim Key     As String
    Dim bEnDe   As Boolean  ' True = encode / False = Decode
    
    Key = txtPassword.Text
    
    For I = 0 To UBound(Files)
        If CBool(LenB(Files(I))) Then
            With CryptoInstance
                If LCase$(Right$(Files(I), 7)) = ".cypher" Then _
                    bEnDe = False _
                Else _
                    bEnDe = True
                
                ff = FreeFile
                Open Files(I) For Binary As #ff
                ReDim Buff(LOF(ff) - 1)
                Get #ff, , Buff
                Close #ff
                
                .CreateSession
                .Key = Key
                If bEnDe Then _
                    Buff = .EncodeBytes(Buff) _
                Else _
                    Buff = .DecodeBytes(Buff)
                .CloseSession
                
                If bEnDe Then _
                    Open Files(I) & ".cypher" For Binary As #ff _
                Else _
                    Open Left$(Files(I), InStrRev(Files(I), ".") - 1) For Binary As #ff
                Put #ff, , Buff
                Close #ff
            End With
        End If
    Next I
End Sub
